[BITS 32]
Init_PIC:

	mov al,00010001b ;ICW4 is sent, cascaded PICs, edge triggering
	out 20h,al		;sending ICW1 to master
	out 0A0h,al		;sending ICW1 to slave

	mov al,20h			; int 20h is base for PIC1
	out 21h,al
	mov al,28h			; int 28h is base for PIC2
	out 0A1h,al

	mov al,00000100b		; IR line 2 is connected to PIC2 (Slave)
	out 21h,al
	mov al,00000010b		; IRQ line 2 of PIC1 is connected to PIC2
	out 0A1h,al

	mov al,01h			; PIC1 is Master
	out 21h,al	
	out 0A1h,al			; PIC 2 is slave

	mov ecx,1000h
wait_8259:
	call Delay32
	dec ecx
	jnz wait_8259

	mov al,11111100b	; mask all interrupts except the first two (IRQ 0,1 and 2)
	;mov al,11111000b	; mask all interrupts except the first three (IRQ 0,1 2 and 3)
	out 21h,al
	mov al,0FFh		; mask all ints on PIC 2 ( 0FFh = 11111111b )
	out 0A1h,al
	ret